#include<bits/stdc++.h>
#define ll long long
using namespace std;
const ll mod=998244353;
bool a[1005][1005];
int mx[1005][1005];
int main(){
	//freopen("plant.in","r",stdin);
	//freopen("plant.out","w",stdout);
	int T,id;
	scanf("%d%d",&T,&id);
	while(T--){
		int n,m,c,f;
		ll ansc=0,ansf=0;
		memset(mx,0,sizeof(0));
		scanf("%d%d%d%d",&n,&m,&c,&f);
		if(f==0) ansf=-1;
		for(int i=1;i<=n;i++){
			for(int j=1;j<=m;j++){
				char c;
				cin>>c;
				a[i][j]=c-'0';
			}
		}
		for(int i=1;i<=n;i++){
			for(int j=m;j>=1;j--){
				if(!a[i][j]){
					mx[i][j]=max(j,mx[i][j+1]);
				}
			}
		}
//		for(int i=1;i<=n;i++){
//			for(int j=1;j<=m;j++){
//				cout<<mx[i][j]<<" ";
//			}
//			cout<<endl;
//		}
		for(int k=1;k<=m;k++){
			for(int i=1;i<=n;i++){
				
			}
		}
		printf("%lld ",ansc%mod);
		if(ansf==-1) printf("0\n");
		else printf("%lld\n",ansf%mod);
	}
	return 0;
}
